library(inline)

src <- '
return(rnorm(as<int>(n), as<double>(mean), as<double>(sd)));
'

rnormRcpp <- cxxfunction(signature(n="integer", mean="numeric", sd="numeric"), src, plugin = "Rcpp")

rnormRcpp(5, 0, 1)

n <- 1000000
library(rbenchmark)

src2 <- '
Function rnorm("rnorm");
return(rnorm(as<int>(n), as<double>(mean), as<double>(sd)));
'

rnormRcppFunc <- cxxfunction(signature(n="integer", mean="numeric", sd="numeric"), src2, plugin = "Rcpp")


print(benchmark(
    rnorm(n),
    rnormRcpp(n, 0, 1),
    rnormRcppFunc(n, 0, 1),
    replications = 5, columns = c("test", "elapsed", "replications")
  ))

