#include <iostream> 
#include <iomanip> 

using namespace std;

// g++ -o class class.cpp

class badMatrix {
// 'bad' because you wouldn't want reinvent the wheel with your own matrix class! private:
  int n_rows, n_cols;
  double* vals;
 public:
  // declarations w/o actually defining the member functions
  badMatrix(int n_rows, int n_cols, double* vals);
  ~badMatrix(void); // destructor
  double operator() (int row, int col);
};

/*
badMatrix::badMatrix(int n_rows, int n_cols, double* vals) {
  // need to use the :: operator because there are local variables (the method arguments) with same names as the class members
  badMatrix::vals = new double(n_rows * n_cols); 
  badMatrix::n_rows = n_rows;  // verbose initialization
  badMatrix::n_cols = n_cols;
  for(int i = 0; i < n_rows*n_cols; i++)
    badMatrix::vals[i] = vals[i];
}
*/

// here are the method definitions

badMatrix::badMatrix(int n_rows, int n_cols, double* vals) :
  n_rows(n_rows), n_cols(n_cols) //succinct initialization
{
  badMatrix::vals = new double[n_rows * n_cols]; 
  for(int i = 0; i < n_rows*n_cols; i++)
    badMatrix::vals[i] = vals[i];
}

double badMatrix::operator() (int row, int col) {
  return vals[row*n_cols + col];
  // note you could even write this to mimic 1-based indexing
}

badMatrix::~badMatrix(void) {
  	delete [] vals;
	cout << "Deallocating memory" << endl;
}

int main() {

  double inputs[6] = {0.0, 1.0, 2.0, 3.0, 4.0, 5.0};
  badMatrix mymat(2, 3, inputs);

  cout << "mymat(0,1): " << mymat(0,1) << endl;
  cout << "mymat(1,0): " << mymat(1,0) << endl;
  
  return 0;
}
