system("R CMD SHLIB fancyPlus.cpp") # you could of course run this outside of R

#system("R CMD SHLIB fancyPlus.C") # C version

dyn.load('fancyPlus.so')

fancyPlus <- function(in1, in2) {
  # R wrapper to the C function
  if(length(in1) != length(in2)) stop("Lengths of vectors must match")
  if(!is.numeric(in1) || !is.numeric(in2)) stop("Must provide numeric vector inputs")
  return(.C('fancyPlus', length = as.integer(length(in1)), input1andOutput = as.double(in1), input2 = as.double(in2))$input1andOutput)
}

tmp1 <- rnorm(10)
tmp2 <- rep(1, 10)
print(fancyPlus(tmp1,tmp2))
print(tmp1)

tmp1 <- rnorm(1e6)
tmp2 <- rnorm(1e6)
print(system.time(tmp1+tmp2))
print(system.time(fancyPlus(tmp1, tmp2)))

fancyPlusFast <- function(len, in1, in2) {
  return(.C('fancyPlus', len, in1, in2)[[2]])
}

system.time(tmp1+tmp2)
system.time(fancyPlusFast(as.integer(1e6), tmp1, tmp2))

`+`  # what does R do with + behind the scenes?

fancyPlusMemUse <- function(in1, in2) {
  print(.Internal(inspect(in1)))
  print(.Internal(inspect(in2)))
  out <- .C('fancyPlus', length(in1), in1, in2)
  print(.Internal(inspect(out[[2]])))
  print(.Internal(inspect(out[[3]])))
  return(out[[2]])
}

tmp1 <- rnorm(10)
tmp2 <- rnorm(10)
.Internal(inspect(tmp1))
out <- fancyPlusMemUse(tmp1,tmp2)
.Internal(inspect(out))

# so, how many copies are made in that whole process of calling the R wrapper, calling the C function and returning the output to the calling environment?
