# internal function, so don't export
format.bytes <- function(x) {
  # returns byte sizes in pretty form
  # example: format.bytes(c(2,1030,2e6))
  round.to.half <- function(x) round(x*2)/2
  s <- as.character(x)
  names(s) <- names(x)
  kilo <- 2^10; mega <- 2^20
  i <- (x >= mega)
  s[i] <- paste(round.to.half(x[i]/mega),"M",sep="")
  i <- (x >= kilo) & (x < mega)
  s[i] <- paste(round(x[i]/kilo),"k",sep="")
  s
}

#' @export
ls.sizes <- function(name=parent.frame(), pretty = T, top = 10, ...) {
  # lists the `top' biggest objects in the given environment
  x <- sapply(ls(name,...),function(x) object.size(get(x)))
  if(top > length(x)) top <- length(x);
  x <- rev(rev(sort(x))[1:top])
  if(pretty) x <- format.bytes(x)
  x <- as.data.frame(x)
  colnames(x) <- "bytes"
  x  
}
