f.ciplot <- function(mean, lower, upper, names = "0", ...){
  n <- length(mean)
  groups <- 1:n
  if(names=="0"){
    names <- 1:n
  }
  plot(groups, mean, xlim = c(0.5, n+0.5), ylim = c(min(lower), max(upper)), type = "p", xaxt = "n", ...)
  for(i in 1:length(mean)){
    segments(i-.2, lower[i], i+.2, lower[i])
    segments(i-.2, upper[i], i+.2, upper[i])
    segments(i, lower[i], i, upper[i])
    text(i, min(lower)-.2, names[i])
  }
  axis(side = 1, at = 1:n, labels = names, tick = F, cex.axis = .5)
}

pmap2 <- function(y, x, xlab = '', ylab = '', col = tim.colors(32), zlim = NULL, shrink = .9, cex = .7, pch = 19, ...){
  if(is.null(zlim)){
    zlim <- range(y, na.rm = T)+c(-1e-15, 1e-15)
  }
  out <- as.numeric(cut(y, breaks = seq(zlim[1], zlim[2], length = length(col)+1)))
  if(shrink<1){
    tmp <- par()$plt
    tmp[2] <- shrink*tmp[2]
    par(plt = tmp)
  }
  plot(x[, 1], x[, 2], col = col[out], xlab = xlab, ylab = ylab, pch = pch, cex = cex, ...)
  if(shrink<1){
    image.plot(y, x = x, add = T, legend.only = T, zlim = zlim, col = col)
  }
  # to plot boundaries over this:
  #tmp=par()$plt
  #tmp[2]=0.9*tmp[2]
  #par(plt=tmp)
  #plot(ccPoly, add=T, border='lightgrey')
}


tsplot <- function(vec, ...){
  leng <- length(vec)
  plot(1:leng, vec, type = "l", ...)
}
